<?php

// +---------------------------------------------------------------------------+
// | Geeklog config.php editor 1.0                                             |
// +---------------------------------------------------------------------------+
// | cedit.php                                                                 |
// | Administration page.                                                      |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Author: Tom Willett       - tomw@pigstye.net                              |
// | Sanity checks by  Paul Mah (paulmah@pbi.com.sg)                           |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

//
// you will need to edit the path to lib-common.php if you put this file anywhere other than
// the admin directory in a standard install -- you will need to edit the configpath below
// if you have your config.php in a non-standard location.
//
require_once('../lib-common.php');

// Required if you put your config.php in path other than your geeklog directory
$configpath = "";    // Leave as "" if within geeklog/ directory

// Use default path if $configpath not set
if ($configpath == "")
    $configpath = $_CONF['path'];

// Only let Root users access this page
if (!SEC_inGroup('Root')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Config edit page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock("Access Denied!!!");
    $display .= "You are illegally trying to access the Config Editor page.  This attempt has been logged";
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}

/**
* Main 
*/


if ($action == 'Save') {
	if (!copy($configpath . "config.php", $configpath . "config.bak")) {
		$display = COM_siteHeader();
        $display .= COM_startBlock("CEdit - Edit Geeklog Config.php");
		$display .= "Unable to copy config.php Permissions Error?";
		$display .= COM_siteFooter(true);
		echo $display;
		exit;
	}
	$fd=fopen($configpath . "config.php",'w');
	if (!$fd) {
		$display = COM_siteHeader();
		//
        $display .= COM_startBlock("CEdit - Edit Geeklog Config.php");
		$display .= "Unable to write config.php Permissions Error?";
		$display .= COM_siteFooter(true);
		echo $display;
		exit;
	}
	fputs($fd,stripslashes($config));
	fclose($fd);
}

$display = COM_siteHeader('none');
$display .= COM_startBlock("CEdit - Edit Geeklog Config.php");
COM_errorLog("Someone has accessed the Config Edit page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
$display .= "<form method='post' action='" . $_CONF['site_admin_url'] . "/cedit.php'>";
$fd = fopen($configpath . "config.php","r");

//  Sanity check in case the path is wrong
//  Wrong path will cause infinite loop and apache to fill up your
//  hard disk with gigabytes of error logs!  
//
if ($fd==false) {
    $error .= "Config.php not found in: ";
    $error .= $configpath . "config.php";
    COM_errorLog($error,1);
    $display .= $error;
} else {
    $buffer = '';
    while (!feof ($fd)) {
        $buffer .= fgets($fd, 4096);
    }
    fclose ($fd);
    $display .= "<textarea rows='20' cols='90' name='config'>" . $buffer . "</textarea>";
    $display .= "<div align='center'><input type='submit' name='action' value='Save'>";
    $display .= "&nbsp;&nbsp;&nbsp <input type='reset' Value='Reset' name='reset'>";
    $display .= "</div>";
    $display .= "</form>";
}
$display .= COM_endBlock();
$display .= COM_siteFooter(false);
echo $display;

?>

